/*===========================================

        TIC TAC TOE 1.0 alpha
        Code     : BMIC

============================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gcmodplay.h> 
#include <ogcsys.h>
#include <malloc.h>
#include <math.h>
#include <unistd.h>
#include <gccore.h>
#include <fat.h>

#include <wiiuse/wpad.h>

#include "gfx/logo.h"
#include "gfx/brasil.h"
#include "gfx/wiibrew.h"
#include "gfx/buttons.h"
#include "gfx/fundo.h"
#include "gfx/fundo_ttt.h"
#include "gfx/tl.h"
#include "gfx/tl_x.h"
#include "gfx/tl_o.h"
#include "giz_mod.h"

#include "GRRLIB/GRRLIB.h"
#include "GRRLIB/fonts/GRRLIB_font1.h"

#define SEQ_LENGTH 15
static MODPlay play;

int board[10] = {2,2,2,2,2,2,2,2,2,2};
int turn = 1;
int player,comp;
int ind_game = 0;
int i;
int res=0;

char *txtBottom;

void go(int n);
void start_game();
void check_draw();
void draw_Cursor();
void draw_Intro();
void player_first();
void reset_Game();

int posTmp, posLine = 1;

Mtx GXmodelView2D;


int main(){
	
	u8 *tex_font1=GRRLIB_LoadTexture(GRRLIB_font1),
	   *tex_fundo=GRRLIB_LoadTexture(fundo),
	   *tex_fundo_ttt=GRRLIB_LoadTexture(fundo_ttt),
	   *tex_tl=GRRLIB_LoadTexture(tl), 
	   *tex_tl_x=GRRLIB_LoadTexture(tl_x), 
	   *tex_tl_o=GRRLIB_LoadTexture(tl_o);

	// Initialise the audio
	AUDIO_Init(NULL);
	MODPlay_Init(&play);

    VIDEO_Init();
    WPAD_Init();
    GRRLIB_InitVideo();
    GRRLIB_Start();
	draw_Intro();

    while(1){ 
        WPAD_ScanPads();
        u32 wpaddown = WPAD_ButtonsDown(0);

		GRRLIB_FillScreen(0xFF000000);

		GRRLIB_DrawImg(0, 0, 640, 480, tex_fundo, 0, 1, 1, 255 );

		if (ind_game == 0)
		{
			GRRLIB_Printf( 120, 110, tex_font1, 0xFFFFFFFF, 6, "TICTACTOE");
			GRRLIB_Printf( 125, 200, tex_font1, 0xFFFFFFFF, 3, " 1 : Play with X");
			GRRLIB_Printf( 125, 230, tex_font1, 0xFFFFFFFF, 3, " 2 : Play with O");
			GRRLIB_Printf( 125, 290, tex_font1, 0xFFFFFFFF, 3, "   HOME : Exit");
			GRRLIB_Printf( 125, 400, tex_font1, 0xFFFFFFFF, 3, "Enter your choice");
		}
		else
		{
			GRRLIB_DrawImg(0, 0, 640, 480, tex_fundo_ttt, 0, 1, 1, 255 );

			if (board[1] == 3)	GRRLIB_DrawImg(120,  70, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[1] == 5) GRRLIB_DrawImg(120,  70, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(120,  70, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[2] == 3)	GRRLIB_DrawImg(290,  65, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[2] == 5) GRRLIB_DrawImg(290,  65, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(290,  65, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[3] == 3)	GRRLIB_DrawImg(440,  70, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[3] == 5) GRRLIB_DrawImg(440,  70, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(440,  70, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[4] == 3)	GRRLIB_DrawImg(120, 190, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[4] == 5) GRRLIB_DrawImg(120, 190, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(120, 190, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[5] == 3)	GRRLIB_DrawImg(290, 180, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[5] == 5) GRRLIB_DrawImg(290, 180, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(290, 180, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[6] == 3)	GRRLIB_DrawImg(440, 190, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[6] == 5) GRRLIB_DrawImg(440, 190, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(440, 190, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[7] == 3)	GRRLIB_DrawImg(120, 310, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[7] == 5) GRRLIB_DrawImg(120, 310, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(120, 310, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[8] == 3)	GRRLIB_DrawImg(290, 300, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[8] == 5) GRRLIB_DrawImg(290, 300, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(290, 300, 80, 80, tex_tl, 0, 1, 1, 185 );

			if (board[9] == 3)	GRRLIB_DrawImg(440, 305, 80, 80, tex_tl_x, 0, 1, 1, 185 );
			else 
			if (board[9] == 5) GRRLIB_DrawImg(440, 305, 80, 80, tex_tl_o, 0, 1, 1, 185 );
			else GRRLIB_DrawImg(440, 305, 80, 80, tex_tl, 0, 1, 1, 185 );

			draw_Cursor();
		}

		if (wpaddown & WPAD_BUTTON_RIGHT) 
		{
			posTmp=posLine;
			if((posTmp!=3) & (posTmp!=6) & (posTmp!=9) & (ind_game==1)) ++posLine;
		}
		if (wpaddown & WPAD_BUTTON_LEFT) 
		{
			posTmp=posLine;
			if((posTmp!=1) & (posTmp!=4) & (posTmp!=7) & (ind_game==1)) --posLine;
		}
		if (wpaddown & WPAD_BUTTON_UP) 
		{
			posTmp=posLine;
			if(((posTmp=posTmp-3)>0) & (ind_game==1)) posLine=posTmp;
		}
		if (wpaddown & WPAD_BUTTON_DOWN)
		{
			posTmp=posLine;
			if(((posTmp=posTmp+3)<10) & (ind_game==1)) posLine=posTmp;
		}
		if (wpaddown & WPAD_BUTTON_1) 
		{
			if(ind_game==0)
			{
				player = 1;
				comp = 0;
				ind_game = 1;
			}
		}
		if (wpaddown & WPAD_BUTTON_2) 
		{
			if(ind_game==0)
			{
				player = 0;
				comp = 1;
				ind_game = 1;
				start_game();
			}
		}
		if (wpaddown & WPAD_BUTTON_A) 
		{
			if(ind_game==1)
			{
				MODPlay_SetMOD(&play, giz_mod);
				MODPlay_Start(&play);
				usleep(400000);
				MODPlay_Stop(&play);
				player_first();
			}
		}
		if (wpaddown & WPAD_BUTTON_PLUS)
		{
			reset_Game();
		}
		if (wpaddown & WPAD_BUTTON_HOME)
		{
			GRRLIB_FadeScr();
			exit(0);
		}
		
		if (i>96)
		{
			if (res == 1)
			{
				txtBottom = "   Player Wins";
			} else
			if (res == 2)
			{
				txtBottom = "  Computer Wins";
			}
			else 
			{
				txtBottom = "    Game Draw";
			}

			GRRLIB_Printf( 125, 400, tex_font1, 0xFFFFFFFF, 3, txtBottom);

			if (i == 97)
			{
				usleep(2000000);
				reset_Game();
			}
			--i;
		}
		GRRLIB_Render();
    }
}
int make2()
{
	if(board[5] == 2)
		return 5;
	if(board[2] == 2)
		return 2;
	if(board[4] == 2)
		return 4;
	if(board[6] == 2)
		return 6;
	if(board[8] == 2)
		return 8;
	return 0;
}

int make4()
{
	if(board[1] == 2)
		return 1;
	if(board[3] == 2)
		return 3;
	if(board[7] == 2)
		return 7;
	if(board[9] == 2)
		return 9;
	return 0;
}

int posswin(int p)
{
// p==1 then X   p==0  then  O
	int i;
	int check_val; //,pos;

	if(p == 1)
		check_val = 18;
	else
		check_val = 50;

	i = 1;
	while(i<=9)//row check
	{
		if(board[i] * board[i+1] * board[i+2] == check_val)
		{
			if(board[i] == 2)
				return i;
			if(board[i+1] == 2)
				return i+1;
			if(board[i+2] == 2)
				return i+2;
		}
		i+=3;
	}

	i = 1;
	while(i<=3)//column check
	{
		if(board[i] * board[i+3] * board[i+6] == check_val)
		{
			if(board[i] == 2)
				return i;
			if(board[i+3] == 2)
				return i+3;
			if(board[i+6] == 2)
				return i+6;
		}
		i++;
	}

	if(board[1] * board[5] * board[9] == check_val)
	{
		if(board[1] == 2)
			return 1;
		if(board[5] == 2)
			return 5;
		if(board[9] == 2)
			return 9;
	}

	if(board[3] * board[5] * board[7] == check_val)
	{
		if(board[3] == 2)
			return 3;
		if(board[5] == 2)
			return 5;
		if(board[7] == 2)
			return 7;
	}
	return 0;
}

void go(int n)
{
	if(turn % 2)
		board[n] = 3;
	else
		board[n] = 5;
	turn++;
}

void player_first()
{

	if((board[posLine] != 3) & (board[posLine] != 5))
	{
		if(posLine == posswin(player))
		{
			go(posLine);
			go(posswin(comp));
			res = 1;
			i=99;
		return;
		}
		else
		{
			if((turn < 10)&(res==0))
			{
				go(posLine);
				start_game();
			}
		}
	}
	else
	{
		txtBottom= "   Select Other";
	}
	check_draw();

}

void start_game()
{
	if(posswin(comp))
	{
		go(posswin(comp));
		res = 2;
		i=99;
		return;
	}
	else
	if(posswin(player))
		go(posswin(player));
	else
	if(make2())
		go(make2());
	else
		go(make4());
	check_draw();
}

void check_draw()
{
	if((turn > 9)&(res==0))
	{
		res = 3;
		i=99;
	}
}

	
void draw_Cursor()
{
	int x=160,y=150;

	switch (posLine)
	{
		case 1:
			x=120;
			y=145;
			break;
		case 2:
			x=290;
			y=145;
			break;
		case 3:
			x=440;
			y=150;
			break;
		case 4:
			x=120;
			y=270;
			break;
		case 5:
			x=290;
			y=260;
			break;
		case 6:
			x=440;
			y=265;
			break;
		case 7:
			x=120;
			y=380;
			break;
		case 8:
			x=290;
			y=380;
			break;
		case 9:
			x=440;
			y=380;
			break;
	}
	
    GRRLIB_Rectangle(x,y,80,5,0xFFFFFF00,1);

}


void draw_Intro()
{
	u8 *tex_logo=GRRLIB_LoadTexture(logo),
	   *tex_brasil=GRRLIB_LoadTexture(brasil),
	   *tex_buttons=GRRLIB_LoadTexture(buttons),
	   *tex_wiibrew=GRRLIB_LoadTexture(wiibrew);
	GRRLIB_DrawImg_FadeInOut(640, 480, tex_logo, 1, 1, 2);
	GRRLIB_DrawImg_FadeInOut(640, 480, tex_brasil, 1, 1, 2);
	GRRLIB_DrawImg_FadeInOut(640, 480, tex_wiibrew, 1, 1, 2);
	GRRLIB_DrawImg_FadeInOut(640, 480, tex_buttons, 1, 1, 1);
}
void reset_Game()
{
    board[1] = 2;
    board[2] = 2;
    board[3] = 2;
    board[4] = 2;
    board[5] = 2;
    board[6] = 2;
    board[7] = 2;
    board[8] = 2;
    board[9] = 2;
	turn = 1;
	ind_game = 0;
	res=0;
	i=0;
}
